{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.SnoptInterface.Classes.SnoptSolver
       (
         SnoptSolver,
         SnoptSolverClass(..),
         snoptSolver__0,
         snoptSolver__1,
         snoptSolver_creator,
         snoptSolver_setOptionsFromFile,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.CToolsInstances ( )
import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.SnoptInterface.Data
import Casadi.SnoptInterface.Enums
import Casadi.Core.Data

-- direct wrapper
foreign import ccall unsafe "casadi__SnoptSolver__CONSTRUCTOR__0" c_casadi__SnoptSolver__CONSTRUCTOR__0
  :: Ptr (Ptr StdString) -> Ptr Function' -> IO (Ptr SnoptSolver')
casadi__SnoptSolver__CONSTRUCTOR__0
  :: Function -> IO SnoptSolver
casadi__SnoptSolver__CONSTRUCTOR__0 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SnoptSolver__CONSTRUCTOR__0 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
snoptSolver__0 :: Function -> IO SnoptSolver
snoptSolver__0 = casadi__SnoptSolver__CONSTRUCTOR__0


-- direct wrapper
foreign import ccall unsafe "casadi__SnoptSolver__CONSTRUCTOR__1" c_casadi__SnoptSolver__CONSTRUCTOR__1
  :: Ptr (Ptr StdString) -> IO (Ptr SnoptSolver')
casadi__SnoptSolver__CONSTRUCTOR__1
  :: IO SnoptSolver
casadi__SnoptSolver__CONSTRUCTOR__1  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SnoptSolver__CONSTRUCTOR__1 errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
snoptSolver__1 :: IO SnoptSolver
snoptSolver__1 = casadi__SnoptSolver__CONSTRUCTOR__1


-- direct wrapper
foreign import ccall unsafe "casadi__SnoptSolver__creator" c_casadi__SnoptSolver__creator
  :: Ptr (Ptr StdString) -> Ptr Function' -> IO (Ptr NLPSolver')
casadi__SnoptSolver__creator
  :: Function -> IO NLPSolver
casadi__SnoptSolver__creator x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SnoptSolver__creator errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
snoptSolver_creator :: Function -> IO NLPSolver
snoptSolver_creator = casadi__SnoptSolver__creator


-- direct wrapper
foreign import ccall unsafe "casadi__SnoptSolver__setOptionsFromFile" c_casadi__SnoptSolver__setOptionsFromFile
  :: Ptr (Ptr StdString) -> Ptr SnoptSolver' -> Ptr StdString -> IO ()
casadi__SnoptSolver__setOptionsFromFile
  :: SnoptSolver -> String -> IO ()
casadi__SnoptSolver__setOptionsFromFile x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SnoptSolver__setOptionsFromFile errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
snoptSolver_setOptionsFromFile :: SnoptSolverClass a => a -> String -> IO ()
snoptSolver_setOptionsFromFile x = casadi__SnoptSolver__setOptionsFromFile (castSnoptSolver x)

